import { LocalExec } from "cdktf-local-exec";
import { Construct } from "constructs";
/**
 * @stability stable
 */
export interface RegistryAuth {
    /**
     * @stability stable
     */
    readonly userName: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly proxyEndpoint: string;
}
/**
 * @stability stable
 */
export interface DockerBuildOptions {
    /**
     * @stability stable
     */
    readonly cwd: string;
    /**
     * @stability stable
     */
    readonly dockerfile?: string;
    /**
     * @stability stable
     */
    readonly tag: string;
    /**
     * @stability stable
     */
    readonly push?: boolean;
    /**
     * @stability stable
     */
    readonly auth?: RegistryAuth;
}
/**
 * @stability stable
 */
export declare class DockerBuild extends LocalExec {
    /**
     * @stability stable
     */
    constructor(scope: Construct, name: string, { cwd, dockerfile, tag, push, auth }: DockerBuildOptions);
}
